/**
* \file 2014_09_04_doxygen_warning_membuffer.c
*/


#define BUFFER_SIZE   1000000 /**< a general define for buffer_size */
/** a general define for mem_size */
#define MEM_SIZE      500000  




/** Dynamic memmory management for the packets.
 */
	/** Definiton of a single memory unit.
	 */
	typedef union unit_u
	{   /** doxygen documentation-bugfix-trial for struct */
		struct
		{
			union unit_u  *next;	/**< Pointer to the next free block. */
			U32 		   size;	/**< Measurement unit is unit_t. */
	
			union unit_u  *my_addr; /**< Original address of the frame. */
	
		} header;  /**< Header. */
	
		/** Requested alignment.
		 */
		U32 	a[4];
	
	} unit_t; /**< doxygen documentation bugfix-trial for unit_t */



/** Locate and align the buffers in correct section.
 */
#define MEM_ATTRIBUTES  /**< Linker mem_attributes definition */



/** Pool for packets without chaining.
 */
/**< any post-documentation for define BUFFER_UNIT_NUMBER */
#define BUFFER_UNIT_NUMBER  \
    ( (BUFFER_SIZE + sizeof (unit_t) - 1) / sizeof (unit_t) + 1 ) 

/**< p_buffer static post-documentation : */
static unit_t p_buffer[BUFFER_UNIT_NUMBER] MEM_ATTRIBUTES; 

/** Pool for buffers without chaining.
 */
/**< any post-documentation for define UNIT_NUMBER */
#define UNIT_NUMBER  \
    ( (MEM_SIZE + sizeof (unit_t) - 1) / sizeof (unit_t) + 1 )

/**< b_buffer static post-documentation */
static unit_t b_buffer[UNIT_NUMBER] MEM_ATTRIBUTES; 


